10 REM  1997/7
12 REM        DRAW ELEMENT, DEFORMATION AND NODAL FORCE OF MODEL DATA 
14 REM           ------- F3DCH.BAS FOR WINDOWS95 -------
16 REM                    BY TAKAYUKI HIRAI
18 DEFSTR Z
20 DIM MV(20,8000),B(3,8000),D(3,8000,3),DU(3,8000),FP(3,8000),Q(3,3)
22 DIM X(24000),C(3,8000,3),E(3,8000),F(3,8000,3),G(3,8000,3)
23 DIM EE(3,8000),FF(3,8000,3),GG(3,8000,3),QQ(2,2)
24 DIM L(24000),M(24000,3),N(24000,3),JJ(12,3),MOU(8000,3),W(6,6)
26 OPEN "DD" FOR INPUT AS #1
28 JJ(1,1)=1:JJ(1,2)=9:JJ(1,3)=2
30 JJ(2,1)=2:JJ(2,2)=10:JJ(2,3)=3
32 JJ(3,1)=3:JJ(3,2)=11:JJ(3,3)=4
34 JJ(4,1)=4:JJ(4,2)=12:JJ(4,3)=1
36 JJ(5,1)=5:JJ(5,2)=17:JJ(5,3)=6
38 JJ(6,1)=6:JJ(6,2)=18:JJ(6,3)=7
40 JJ(7,1)=7:JJ(7,2)=19:JJ(7,3)=8
42 JJ(8,1)=8:JJ(8,2)=20:JJ(8,3)=5
44 JJ(9,1)=1:JJ(9,2)=13:JJ(9,3)=5
45 JJ(10,1)=2:JJ(10,2)=14:JJ(10,3)=6
46 JJ(11,1)=3:JJ(11,2)=15:JJ(11,3)=7
47 JJ(12,1)=4:JJ(12,2)=16:JJ(12,3)=8
48 PRINT " "
49 INPUT #1,ZZ:ZM=LEFT$(ZZ,5)
50 INPUT #1,NELE,NODT,NMAT,NN
54 PRINT "      ALL ELEMENTS FIGURE                       ,  FIGU = 0"
55 PRINT "      SPECIFIC ELEMENTS FIGURE                  ,  FIGU = 1"
56 PRINT "      BOUNDARY CONDITION OF ALL ELEMENTS        ,  FIGU = 2"
57 PRINT "      BOUNDARY CONDITION OF SPECIFIC ELEMENTS   ,  FIGU = 3"
58 PRINT " "
59 INPUT "                   FIGU = ";FIGU
60 IF FIGU=0 THEN GOTO 131
61 IF FIGU=2 THEN GOTO 131
62 PRINT " "
63 PRINT "  INPUT THE ELEMENTS NUMBER TO DRAW"
64 PRINT "       INPUT FROM FILE D2          WAY = 1"
65 PRINT "       INPUT FROM KEY-BOARD        WAY = 2"
66 PRINT " ":INPUT "             WAY =";WAY
68 PRINT " "
70 IF WAY=2 THEN GOTO 98
74 OPEN "D2" FOR INPUT AS #2
76 FOR I9=1 TO 2000
77 IF EOF(2)=-1 THEN GOTO 96
78 INPUT #2,MOU(I9,1)
80 IF MOU(I9,1)>89999 THEN GOTO 96
82 IF MOU(I9,1)<1 THEN GOTO 88
84 IF MOU(I9,1)>NELE THEN GOTO 88 
86 NEXT I9
88 PRINT " ":PRINT " WRONG ELEMENT NUMBER IN FILE D2"
90 PRINT " ":PRINT " WRONG ELEMENT NUMBER = ";MOU(I9,1)
92 PRINT " ":INPUT " PUSH ENTER KEY ";Z3
94 GOTO 1900
96 CLOSE #2:GOTO 120
98 PRINT "         INPUT ELEMENT NUMBER,   END DATA = 99999 "
100 FOR I9=1 TO 2000
102 PRINT " ":INPUT "        ELEMENT NUMBER =";MOU(I9,1)
104 IF MOU(I9,1)>89999! THEN GOTO 120
106 IF MOU(I9,1)<1 THEN GOTO 112
108 IF MOU(I9,1)>NELE THEN GOTO 112
110 GOTO 118
112 PRINT " ":PRINT "  BAD : WRONG ELEMENT NUMBER TO DRAW = ";MOU(I9,1)
114 PRINT " ":PRINT "           INPUT AGAIN"
116 PRINT " ":GOTO 102
118 NEXT I9
120 DRE=I9-1
131 PRINT " "
132 input "            SCALE OF DISPLACEMENT =";SCD
133 INPUT "            SCALE OF NODAL FORCE  =";SCF
134 IF ABS(SCD)<0.000001 THEN SCD=0.000001
135 IF ABS(SCF)<0.000001 THEN SCF=0.000001
136 PRINT " "
163 PRINT "   INPUT VIEW DIRECTION":
164 PRINT "      Q1 = ANGLE(DEGREE) FROM X-AXIS TOWARD Y-AXIS" 
165 PRINT "      Q2 = ANGLE(DEGREE) FROM XY-PLANE" 
166 PRINT " ":INPUT "       Q1 =";Q1
167 PRINT " ":INPUT "       Q2 =";Q2:PRINT " "
168 PRINT "   INPUT ROTATION OF VIEW DIRECTION"
169 PRINT "      Q3 = ANGLE(DEGREE) OF LEFT-HANDED ROTATION"
170 PRINT " ":INPUT "       Q3 =";Q3
171 P1=Q1*0.017453:P2=Q2*0.017453:P9=COS(P2)
172 V1=COS(P1)*P9:V2=SIN(P1)*P9:V3=SIN(P2)
175 VV=SQR(V1*V1+V2*V2+V3*V3)
176 IF VV>0.0001 THEN GOTO 179
177 PRINT " ":PRINT " BAD Q1,Q2     INPUT AGAIN"
178 GOTO 136
179 V1=V1/VV:V2=V2/VV:V3=V3/VV
180 H1=SIN(P1):H2=-COS(P1):H3=0
186 VV=SQR(H1*H1+H2*H2+H3*H3)
188 IF VV>0.0001 THEN GOTO 194
190 PRINT " ":PRINT " BAD Q1,Q2     INPUT AGAIN"
192 GOTO 136
194 H1=H1/VV:H2=H2/VV:H3=H3/VV
196 T1=V2*H3-V3*H2:T2=-V1*H3+V3*H1:T3=V1*H2-V2*H1
198 VV=H1*V2*T3+H2*V3*T1+H3*V1*T2-H1*V3*T2-H2*V1*T3-H3*V2*T1
200 IF ABS(VV)>0.001 THEN GOTO 204
201 PRINT " ":PRINT " BAD VIEW DIRECTION     INPUT AGAIN"
202 GOTO 136
204 HH=H1*V1+H2*V2+H3*V3:HHH=HH*HH
206 IF HHH<0.0001 THEN GOTO 242
207 PRINT " ":PRINT " BAD VIEW DIRECTION     INPUT AGAIN"
208 GOTO 136
242 Q(1,1)=(V2*T3-V3*T2)/VV:Q(1,2)=-(H2*T3-H3*T2)/VV:Q(1,3)=(H2*V3-H3*V2)/VV
244 Q(2,1)=-(V1*T3-V3*T1)/VV:Q(2,2)=(H1*T3-H3*T1)/VV:Q(2,3)=-(H1*V3-H3*V1)/VV
245 Q(3,1)=(V1*T2-V2*T1)/VV:Q(3,2)=-(H1*T2-H2*T1)/VV:Q(3,3)=(H1*V2-H2*V1)/VV
250 P3=Q3*0.017453:P4=SIN(P3):P5=COS(P3)
252 QQ(1,1)=P5:QQ(1,2)=P4:QQ(2,1)=-P4:QQ(2,2)=P5
260 REM ------- READING MODEL DATA --------  
262 PRINT" ":PRINT "   MODEL = ";ZM
265 PRINT " "
266 PRINT " ELEMENTS, TOTAL NODES, MATERIALS, GAUSS POINTS ="
267 PRINT NELE,NODT,NMAT,NN
268 PRINT " ":INPUT " PUSH ENTER KEY ";Z3
274 FOR I=1 TO NODT
276 INPUT #1,A1,B(1,I),B(2,I),B(3,I)
277 FP(1,I)=0.0:FP(2,I)=0.0:FP(3,I)=0.0:DU(1,I)=0.0:DU(2,I)=0.0:DU(3,I)=0.0
278 PRINT A1,B(1,I),B(2,I),B(3,I):NEXT I
285 PRINT " ":INPUT " PUSH ENTER KEY ";Z3:PRINT " "
320 FOR I=1 TO NELE
322 INPUT #1,ZZ
323 LL=LEN(ZZ):LK=LL-40
324 AA1=VAL(LEFT$(ZZ,LK))
325 Z1=RIGHT$(ZZ,40):A1=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,36):A2=VAL(LEFT$(Z1,4))
326 Z1=RIGHT$(ZZ,32):A3=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,28):A4=VAL(LEFT$(Z1,4))
328 Z1=RIGHT$(ZZ,24):A5=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,20):A6=VAL(LEFT$(Z1,4))
330 Z1=RIGHT$(ZZ,16):A7=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,12):A8=VAL(LEFT$(Z1,4))
332 Z1=RIGHT$(ZZ,8):A9=VAL(LEFT$(Z1,4)):A0=VAL(RIGHT$(ZZ,4))
333 INPUT #1,ZZ
335 LL=LEN(ZZ):LK=LL-50
336 B1=VAL(LEFT$(ZZ,LK)):Z1=RIGHT$(ZZ,50):B2=VAL(LEFT$(Z1,4))
338 Z1=RIGHT$(ZZ,46):B3=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,42):B4=VAL(LEFT$(Z1,4))
339 Z1=RIGHT$(ZZ,38):B5=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,34):B6=VAL(LEFT$(Z1,4))
340 Z1=RIGHT$(ZZ,30):B7=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,26):B8=VAL(LEFT$(Z1,4))
342 Z1=RIGHT$(ZZ,22):B9=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,18):B0=VAL(LEFT$(Z1,4))
343 Z1=RIGHT$(ZZ,14):AA2=VAL(LEFT$(Z1,4)):AA3=VAL(RIGHT$(Z4,10))
344 MV(1,I)=A1:MV(2,I)=A2:MV(3,I)=A3:MV(4,I)=A4:MV(5,I)=A5
346 MV(6,I)=A6:MV(7,I)=A7:MV(8,I)=A8:MV(9,I)=A9:MV(10,I)=A0
348 MV(11,I)=B1:MV(12,I)=B2:MV(13,I)=B3:MV(14,I)=B4:MV(15,I)=B5
350 MV(16,I)=B6:MV(17,I)=B7:MV(18,I)=B8:MV(19,I)=B9:MV(20,I)=B0
393 PRINT AA1,MV(1,I),MV(2,I),MV(3,I),MV(4,I),MV(5,I),MV(6,I),MV(7,I),MV(8,I),MV(9,I),MV(10,I)
395 PRINT MV(11,I),MV(12,I),MV(13,I),MV(14,I),MV(15,I),MV(16,I),MV(17,I),MV(18,I),MV(19,I),MV(20,I),AA2,AA3
400 NEXT I
414 PRINT " ":INPUT " PUSH ENTER KEY ";Z3
416 FOR I=1 TO NMAT
418 INPUT #1,ZZ:PRINT ZZ:NEXT I
420 PRINT " ":INPUT " PUSH ENTER KEY ";Z3
421 FOR I=1 TO 8000
422 IF EOF(1)=-1 THEN GOTO 443
423 INPUT #1,A1
427 IF A1>89999 THEN GOTO 443
429 INPUT #1,A2,A3,A4,A5,A6,A7:PRINT A1;A2;A3;A4;A5;A6;A7
430 IF A2=0 THEN FP(1,A1)=A5 
432 IF A3=0 THEN FP(2,A1)=A6 
434 IF A4=0 THEN FP(3,A1)=A7 
436 IF A2=1 THEN DU(1,A1)=A5 
438 IF A3=1 THEN DU(2,A1)=A6 
440 IF A4=1 THEN DU(3,A1)=A7 
442 NEXT I
443 REM
445 PRINT " ":INPUT " PUSH ENTER KEY ";Z3
490 IF FIGU=0 THEN GOTO 550
492 IF FIGU=2 THEN GOTO 550
527 DRN=20                    
528 FOR I=1 TO 20
530 MOU(I,2)=MV(I,MOU(1,1))
532 NEXT I
534 IF DRE=1 THEN GOTO 562
536 FOR I=2 TO DRE
538 FOR J=1 TO 20
542 FOR K=1 TO DRN
543 IF MV(J,MOU(I,1))=MOU(K,2) THEN GOTO 546
544 NEXT K
545 DRN=DRN+1:MOU(DRN,2)=MV(J,MOU(I,1))
546 NEXT J
547 NEXT I
548 GOTO 562
550 DRE=NELE:DRN=NODT
552 FOR I=1 TO NELE
554 MOU(I,1)=I:NEXT I
556 FOR I=1 TO NODT
558 MOU(I,2)=I:NEXT I
562 REM
564 REM  ----------- SCALING ----------
566 FOR I=1 TO NODT
568 FOR J=1 TO 3
572 FOR K=1 TO 3
575 C(J,I,K)=B(J,I):D(J,I,K)=B(J,I):NEXT K
580 C(J,I,J)=C(J,I,J)+DU(J,I)*SCD
586 D(J,I,J)=D(J,I,J)+FP(J,I)*SCF
588 NEXT J:NEXT I
590 FOR I=1 TO NODT
591 FOR J=1 TO 3
592 EE(J,I)=0.0
593 FF(J,I,1)=0.0:FF(J,I,2)=0.0:FF(J,I,3)=0.0
594 GG(J,I,1)=0.0:GG(J,I,2)=0.0:GG(J,I,3)=0.0
596 FOR K=1 TO 3
598 EE(J,I)=EE(J,I)+B(K,I)*Q(K,J)
599 FOR KK=1 TO 3
600 FF(J,I,KK)=FF(J,I,KK)+C(K,I,KK)*Q(K,J)
601 GG(J,I,KK)=GG(J,I,KK)+D(K,I,KK)*Q(K,J)
602 NEXT KK
603 NEXT K:NEXT J:NEXT I
620 FOR I=1 TO NODT
622 E(2,I)=EE(2,I)
624 FOR K=1 TO 3
626 F(2,I,K)=FF(2,I,K):G(2,I,K)=GG(2,I,K):NEXT K
628 E(1,I)=QQ(1,1)*EE(1,I)+QQ(1,2)*EE(3,I)
629 E(3,I)=QQ(2,1)*EE(1,I)+QQ(2,2)*EE(3,I)
630 FOR KK=1 TO 3
632 F(1,I,KK)=QQ(1,1)*FF(1,I,KK)+QQ(1,2)*FF(3,I,KK)
633 F(3,I,KK)=QQ(2,1)*FF(1,I,KK)+QQ(2,2)*FF(3,I,KK)
634 G(1,I,KK)=QQ(1,1)*GG(1,I,KK)+QQ(1,2)*GG(3,I,KK)
635 G(3,I,KK)=QQ(2,1)*GG(1,I,KK)+QQ(2,2)*GG(3,I,KK)
636 NEXT KK
638 NEXT I
654 FOR I=1 TO NODT
655 E(3,I)=-E(3,I)
656 FOR KK=1 TO 3
658 F(3,I,KK)=-F(3,I,KK):G(3,I,KK)=-G(3,I,KK)
660 NEXT KK:NEXT I
680 XA=999999!:XB=-999999!:YA=999999!:YB=-999999!
683 FOR I9=1 TO DRN
684 I=MOU(I9,2)
686 IF XA>E(1,I) THEN XA=E(1,I)
688 IF XB<E(1,I) THEN XB=E(1,I)
690 IF YA>E(3,I) THEN YA=E(3,I)
692 IF YB<E(3,I) THEN YB=E(3,I)
694 FOR KK=1 TO 3
696 IF XA>F(1,I,KK) THEN XA=F(1,I,KK)
700 IF XB<F(1,I,KK) THEN XB=F(1,I,KK)
710 IF YA>F(3,I,KK) THEN YA=F(3,I,KK)
720 IF YB<F(3,I,KK) THEN YB=F(3,I,KK)
730 IF XA>G(1,I,KK) THEN XA=G(1,I,KK)
740 IF XB<G(1,I,KK) THEN XB=G(1,I,KK)
750 IF YA>G(3,I,KK) THEN YA=G(3,I,KK)
760 IF YB<G(3,I,KK) THEN YB=G(3,I,KK)
770 NEXT KK
780 NEXT I9
790 XM=XB-XA:YM=YB-YA
800 SS=180/YM
810 IF XM*4>YM*6 THEN SS=290/XM
820 FOR I=1 TO NODT
830 L(2*I-1)=(E(1,I)-XA)*SS*2+10
840 L(2*I)=195-(E(3,I)-YA)*SS
845 FOR KK=1 TO 3
850 M(2*I-1,KK)=(F(1,I,KK)-XA)*SS*2+10
860 M(2*I,KK)=195-(F(3,I,KK)-YA)*SS
870 N(2*I-1,KK)=(G(1,I,KK)-XA)*SS*2+10
880 N(2*I,KK)=195-(G(3,I,KK)-YA)*SS
885 NEXT KK
890 NEXT I
900 REM
910 REM ----- DRAW ELEMENT FIGURE -----
920 #include"WINDOWS.BI"
930 var FORM as object
940 var BITMAP1 as object
950 SETMAPMODE 1
955 SETREDRAWMODE 1
960 FORM.ATTACH GETHWND
962 BITMAPOBJECT BITMAP1
964 view (0,0)-(636,433)
966 window (0,-3)-(620,210)
968 color 0,15
970 CLS
973 if FIGU>1 then goto 976
974 print"    MODEL=";ZM:GOTO 990
976 T9=8/SS/SCD:T8=8/SS/SCF
988 PRINT"    RED FORCE SCALE=";T8;"GREEN DISPLACEMENT SCALE=";T9;"MODEL=";ZM
990 FOR I6=1 TO DRE
994 I=MOU(I6,1)
996 FOR J=1 TO 12
1000 X1=L(2*MV(JJ(J,1),I)-1):X2=L(2*MV(JJ(J,2),I)-1):X3=L(2*MV(JJ(J,3),I)-1)
1002 Y1=L(2*MV(JJ(J,1),I)):Y2=L(2*MV(JJ(J,2),I)):Y3=L(2*MV(JJ(J,3),I))
1004 FOR K=1 TO 8:K1=-1+(K-1)/4:K2=-1+K/4
1006 XX1=CINT(K1*(K1-1)*X1/2+(1-K1)*(K1+1)*X2+K1*(K1+1)*X3/2)
1008 YY1=CINT(K1*(K1-1)*Y1/2+(1-K1)*(K1+1)*Y2+K1*(K1+1)*Y3/2)
1010 XX2=CINT(K2*(K2-1)*X1/2+(1-K2)*(K2+1)*X2+K2*(K2+1)*X3/2)
1012 YY2=CINT(K2*(K2-1)*Y1/2+(1-K2)*(K2+1)*Y2+K2*(K2+1)*Y3/2)
1014 line(XX1,YY1)-(XX2,YY2),pset,0:NEXT K
1015 NEXT J:NEXT I6
1020 REM
1030 REM ----- DRAW BOUNDARY CONDITION -----
1040 if FIGU<2 then goto 1850
1330 FOR I6=1 TO DRN
1335 I=MOU(I6,2)
1340 FOR KK=1 TO 3
1360 X1=CINT(L(2*I-1)):Y1=CINT(L(2*I))
1365 IF ABS(FP(KK,I)*SCF*SS*2)<1 THEN GOTO 1375
1370 X2=CINT(N(2*I-1,KK)):Y2=CINT(N(2*I,KK))
1372 line(X1,Y1)-(X2,Y2),pset,5:GOTO 1390
1375 IF ABS(DU(KK,I)*SCD*SS*2)<1 THEN GOTO 1390
1380 X2=CINT(M(2*I-1,KK)):Y2=CINT(M(2*I,KK))
1382 line(X1,Y1)-(X2,Y2),pset,8
1390 IF ABS(FP(KK,I)*SCF*SS*2)<2 THEN GOTO 1394
1392 UU=(N(2*I-1,KK)-L(2*I-1))*2:VV=N(2*I,KK)-L(2*I):GOTO 1400
1394 IF ABS(DU(KK,I)*SCD*SS*2)<2 THEN GOTO 1530
1396 UU=(M(2*I-1,KK)-L(2*I-1))*2:VV=M(2*I,KK)-L(2*I)
1400 IF ABS(UU)<0.00001 GOTO 1470
1420 FUV=ATN(VV/UU)
1430 IF UU>0.0 THEN GOTO 1490      
1440 FUV=FUV+3.1416
1450 IF VV<0.0 THEN FUV=FUV-6.2832
1460 GOTO 1490       
1470 FUV=1.5708
1480 IF VV<0.0 THEN FUV=FUV-3.1416
1490 F1=CINT(COS(FUV+2.3562)*4):F2=CINT(SIN(FUV+2.3562)*2)
1500 F3=CINT(COS(FUV-2.3562)*4):F4=CINT(SIN(FUV-2.3562)*2)
1510 line(X2,Y2)-(X2+F1,Y2+F2),pset,3
1520 line(X2,Y2)-(X2+F3,Y2+F4),pset,3
1530 NEXT KK       
1540 NEXT I6
1550 Line(5,6)-(21,6),pset,5
1560 line(5,6)-(5,-2),pset,9
1840 REM
1850 BITMAP1.CREATEBITMAP 636,433
1852 BITMAP1.BITBLT 0,0,636,433,FORM,0,-3
1854 BITMAP1.SAVEFILE"AAA.BMP"
1856 BITMAP1.DELETEOBJECT
1858 cls
1860 BITMAP1.LOADFILE"AAA.BMP"
1862 FORM.BITBLT 0,-3,636,433,BITMAP1,0,0
1863 for I8=1 to 9000
1866 wait 10
1870 Z4=inkey$
1880 if Z4="Q" then goto 1900
1882 if Z4="q" then goto 1900
1884 if Z4="S" then goto 1900
1886 if Z4="s" then goto 1900
1888 next I8
1900 END
 